Fix xattrs test on OS X.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
6f481bb0 20tmpdir="$scratchdir"
e3442095
WD
21fromdir="$tmpdir/from"
22todir="$tmpdir/to"
23chkdir="$tmpdir/chk"
3a4c683f 24
fc29efc3
WD
25# For itemized output:
26all_plus='+++++++++'
27allspace=' '
28dots='.....' # trailing dots after changes
0b67d5e3 29tab_ch=' ' # a single tab character
fc29efc3 30
2094283b 31# Berkley's nice.
96553aa7 32PATH="$PATH:/usr/ucb"
2094283b 33
21706678 34if diff -u "$suitedir/rsync.fns" "$suitedir/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
35 diffopt="-u"
36else
37 diffopt="-c"
38fi
39
a98cad00
WD
40HOME="$scratchdir"
41export HOME
42
3a4c683f
MP
43runtest() {
44 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
45 if eval "$2"
46 then
6f481bb0 47 echo "$ECHO_T done."
501972bf
MP
48 return 0
49 else
6f481bb0 50 echo "$ECHO_T failed!"
501972bf
MP
51 return 1
52 fi
3a4c683f
MP
53}
54
844810d6
WD
55set_cp_destdir() {
56 while test $# -gt 1; do
57 shift
58 done
59 destdir="$1"
60}
61
62# Perform a "cp -p", making sure that timestamps are really the same,
63# even if the copy rounded microsecond times on the destination file.
64cp_touch() {
65 cp -p "${@}" || test_fail "cp -p failed"
66 if test $# -gt 2 -o -d "$2"; then
67 set_cp_destdir "${@}" # sets destdir var
68 while test $# -gt 1; do
69 destname="$destdir/`basename $1`"
70 touch -r "$destname" "$1" "$destname"
71 shift
72 done
73 else
74 touch -r "$2" "$1" "$2"
75 fi
76}
77
757287d8
WD
78# Call this if you want to filter out verbose messages (-v or -vv) from
79# the output of an rsync run (whittling the output down to just the file
80# messages). This isn't needed if you use -i without -v.
81filter_outfile() {
82 sed -e '/^building file list /d' \
9544261a 83 -e '/^sending incremental file list/d' \
757287d8
WD
84 -e '/^created directory /d' \
85 -e '/^done$/d' \
86 -e '/ --whole-file$/d' \
87 -e '/^total: /d' \
332cf6df
WD
88 -e '/^client charset: /d' \
89 -e '/^server charset: /d' \
757287d8
WD
90 -e '/^$/,$d' \
91 <"$outfile" >"$outfile.new"
92 mv "$outfile.new" "$outfile"
93}
94
3a4c683f
MP
95printmsg() {
96 echo "$1"
97}
98
6773a779 99rsync_ls_lR() {
db9c9e27 100 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
101}
102
8e7f3107
WD
103get_testuid() {
104 id 2>/dev/null | sed 's/^[^0-9]*\([0-9][0-9]*\).*/\1/'
105}
106
18d7e9f4 107check_perms() {
eace352b
WD
108 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
109 if test $perms = $2; then
110 return 0
111 fi
112 echo "permissions: $perms on $1"
113 echo "should be: $2"
114 test_fail "failed test $3"
18d7e9f4
WD
115}
116
dfef3f10
MP
117rsync_getgroups() {
118 "$TOOLDIR/getgroups"
57835c00
MP
119}
120
121
e052b21f 122####################
6f481bb0 123# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 124
3a4c683f 125hands_setup() {
501972bf 126 # Clean before creation
6f481bb0
WD
127 rm -rf "$fromdir"
128 rm -rf "$todir"
3d807132 129
e3442095
WD
130 [ -d "$tmpdir" ] || mkdir "$tmpdir"
131 [ -d "$fromdir" ] || mkdir "$fromdir"
132 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 133
e052b21f
MP
134 # On some BSD systems, the umask affects the mode of created
135 # symlinks, even though the mode apparently has no effect on how
136 # the links behave in the future, and it cannot be changed using
137 # chmod! rsync always sets its umask to 000 so that it can
138 # accurately recreate permissions, but this script is probably run
139 # with a different umask.
140
141 # This causes a little problem that "ls -l" of the two will not be
142 # the same. So, we need to set our umask before doing any creations.
143
3a4c683f 144 # set up test data
6f481bb0
WD
145 touch "$fromdir/empty"
146 mkdir "$fromdir/emptydir"
e8ca5901 147
571a4b26 148 # a hundred lines of text or so
6f481bb0 149 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 150
6f481bb0 151 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 152 umask 0
6f481bb0 153 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 154 umask 022
0154b302 155
db10766a 156 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
157 mkdir "$fromdir/dir"
158 cp "$fromdir/text" "$fromdir/dir"
159 mkdir "$fromdir/dir/subdir"
160 echo some data > "$fromdir/dir/subdir/foobar.baz"
161 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
162 if [ -r /etc ]; then
163 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
164 else
165 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
166 fi
6f481bb0 167 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
168 if [ -r /bin ]; then
169 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
170 else
171 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
172 fi
7d691654 173
8f98c608 174# echo testing head:
6f481bb0 175# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 176}
3fedd74b
MP
177
178
99cdaff7
MP
179####################
180# Many machines do not have "mkdir -p", so we have to build up long paths.
181# How boring.
5ef8c5c6 182makepath() {
d1798a2f
WD
183 for p in "${@}"; do
184 (echo " makepath $p"
185
99cdaff7
MP
186 # Absolut Unix.
187 if echo $p | grep '^/' >/dev/null
188 then
189 cd /
190 fi
191
d1798a2f 192 # This will break if $p contains a space.
99cdaff7
MP
193 for c in `echo $p | tr '/' ' '`
194 do
112e7311
MP
195 if [ -d "$c" ] || mkdir "$c"
196 then
197 cd "$c" || return $?
198 else
199 echo "failed to create $c" >&2; return $?
200 fi
d1798a2f
WD
201 done)
202 done
99cdaff7
MP
203}
204
205
206
3fedd74b
MP
207###########################
208# Run a test (in '$1') then compare directories $2 and $3 to see if
209# there are any difference. If there are, explain them.
210
f494f286
MP
211# So normally basically $1 should be an rsync command, and $2 and $3
212# the source and destination directories. This is only good when you
213# expect to transfer the whole directory exactly as is. If some files
214# should be excluded, you might need to use something else.
215
3fedd74b 216checkit() {
3fedd74b 217 failed=
3fedd74b 218
cf72f204
MP
219 # We can just write everything to stdout/stderr, because the
220 # wrapper hides it unless there is a problem.
221
222 echo "Running: \"$1\""
223 eval "$1"
3fedd74b
MP
224 status=$?
225 if [ $status != 0 ]; then
8b6ebde1 226 failed="$failed status=$status"
3fedd74b
MP
227 fi
228
cf72f204
MP
229 echo "-------------"
230 echo "check how the directory listings compare with diff:"
231 echo ""
6f481bb0
WD
232 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
233 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
8b6ebde1 234 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed="$failed dir-diff"
30688bf1
WD
235
236 echo "-------------"
237 echo "check how the files compare with diff:"
238 echo ""
239 if [ "x$4" != x ]; then
240 echo " === Skipping (as directed) ==="
241 else
8b6ebde1 242 diff -r $diffopt "$2" "$3" || failed="$failed file-diff"
30688bf1
WD
243 fi
244
245 echo "-------------"
6f481bb0 246 if [ -z "$failed" ] ; then
3fedd74b 247 return 0
3fedd74b 248 fi
8b6ebde1
WD
249
250 echo "Failed: $failed"
251 return 1
3fedd74b
MP
252}
253
863dff51 254
4a7cb3e8 255build_rsyncd_conf() {
d2094cc3
MP
256 # Build an appropriate configuration file
257 conf="$scratchdir/test-rsyncd.conf"
258 echo "building configuration $conf"
259
260 port=2612
261 pidfile="$scratchdir/rsyncd.pid"
262 logfile="$scratchdir/rsyncd.log"
e5255195 263 hostname=`uname -n`
d2094cc3 264
aa381148
WD
265 uid_setting='uid = 0'
266 gid_setting='gid = 0'
8e7f3107 267 case `get_testuid` in
aa381148
WD
268 0) ;;
269 *)
270 # Non-root cannot specify uid & gid settings
271 uid_setting="#$uid_setting"
272 gid_setting="#$gid_setting"
273 ;;
274 esac
275
6f481bb0 276 cat >"$conf" <<EOF
3aae15ec 277# rsyncd configuration file autogenerated by $0
d2094cc3 278
3aae15ec
MP
279pid file = $pidfile
280use chroot = no
9585b276 281munge symlinks = no
e73eed85 282hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
3aae15ec 283log file = $logfile
2ae4126a
WD
284log format = %i %h [%a] %m (%u) %l %f%L
285transfer logging = yes
0e9c3564 286exclude = ? foobar.baz
951e826b 287max verbosity = 4
aa381148
WD
288$uid_setting
289$gid_setting
98c1b325 290
2e6c7f45 291[test-from]
6f481bb0 292 path = $fromdir
3aae15ec 293 read only = yes
0e9c3564 294 comment = r/o
d2094cc3 295
2e6c7f45 296[test-to]
6f481bb0 297 path = $todir
3aae15ec 298 read only = no
0e9c3564 299 comment = r/w
2ae4126a
WD
300
301[test-scratch]
302 path = $scratchdir
303 read only = no
0e9c3564
WD
304
305[test-hidden]
306 path = $fromdir
307 list = no
d2094cc3 308EOF
2d8f9b1d
WD
309
310 # Build a helper script to ignore exit code 23
311 ignore23="$scratchdir/ignore23"
312 echo "building help script $ignore23"
313
314 cat >"$ignore23" <<'EOT'
315if "${@}"; then
316 exit
317fi
318
319ret=$?
320
321if test $ret = 23; then
322 exit
323fi
324
325exit $ret
326EOT
327chmod +x "$ignore23"
d2094cc3
MP
328}
329
330
3cd2af41 331build_symlinks() {
3cd2af41
MP
332 mkdir "$fromdir"
333 date >"$fromdir/referent"
334 ln -s referent "$fromdir/relative"
335 ln -s "$fromdir/referent" "$fromdir/absolute"
336 ln -s nonexistent "$fromdir/dangling"
1db8b61d 337 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
338}
339
340test_fail() {
341 echo "$@" >&2
342 exit 1
343}
344
a217ad30
MP
345test_skipped() {
346 echo "$@" >&2
6f481bb0 347 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
348 exit 77
349}
350
be2f866b
MP
351# It failed, but we expected that. don't dump out error logs,
352# because most users won't want to see them. But do leave
353# the working directory around.
354test_xfail() {
355 echo "$@" >&2
356 exit 78
357}
358
d1239eae
MP
359# Determine what shell command will appropriately test for links.
360ln -s foo "$scratchdir/testlink"
361for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
362do
363 for switch in -h -L
364 do
365 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
366 then
367 # how nice
368 TEST_SYMLINK_CMD="$cmd $switch"
369 # i wonder if break 2 is portable?
370 break 2
371 fi
372 done
373done
cca4e067
MP
374# ok, now get rid of it
375rm "$scratchdir/testlink"
d1239eae
MP
376
377
378if [ "x$TEST_SYMLINK_CMD" = 'x' ]
379then
380 test_fail "Couldn't determine how to test for symlinks"
381else
382 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
383fi
384
385
d96d3893
MP
386# Test whether something is a link, allowing for shell peculiarities
387is_a_link() {
d1239eae
MP
388 # note the variable contains the first option and therefore is not quoted
389 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
390}
391
77867907
MP
392
393# We need to set the umask to be reproducible. Note also that when we
394# do some daemon tests as root, we will setuid() and therefore the
395# directory has to be writable by the nobody user in some cases. The
396# best thing is probably to explicitly chmod those directories after
397# creation.
398
ad301e48 399umask 022